diff -urN config.org/display-mailrecip.html config/display-mailrecip.html
--- config.org/display-mailrecip.html	1970-01-01 09:00:00.000000000 +0900
+++ config/display-mailrecip.html	2011-03-03 13:37:55.000000000 +0900
@@ -0,0 +1,386 @@
+<!-- BEGIN COPYRIGHT BLOCK
+ This Program is free software; you can redistribute it and/or modify it under
+ the terms of the GNU General Public License as published by the Free Software
+ Foundation; version 2 of the License.
+
+ This Program is distributed in the hope that it will be useful, but WITHOUT
+ ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+ FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
+
+ You should have received a copy of the GNU General Public License along with
+ this Program; if not, write to the Free Software Foundation, Inc., 59 Temple
+ Place, Suite 330, Boston, MA 02111-1307 USA.
+
+ 
+ Copyright (C) 2001 Sun Microsystems, Inc. Used by permission.
+ Copyright (C) 2005 Red Hat, Inc.
+ All rights reserved.
+  END COPYRIGHT BLOCK -->
+<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN"
+    "http://www.w3.org/TR/html4/strict.dtd">
+<HTML>
+<!-- HEAD -->
+<!-- mailrecipient directory entry -->
+<!-- DS_OBJECTCLASS "value=mailRecipient" -->
+
+<!-- DS_ENTRYBEGIN -->
+<TITLE>
+<!-- IF "Adding" -->
+New
+<!-- ENDIF // Adding -->
+MailRecipient Entry -
+<!-- DS_ATTRIBUTE "attr=dn" "syntax=dn" "options=nolink" -->
+</TITLE>
+
+<SCRIPT type="text/javascript">
+<!-- Hide from non-JavaScript-capable browsers
+function showVCard()
+{
+<!-- DS_ATTRIBUTE "attr=_vcard" "options=link,entities" "mimetype=text/x-vcard" "prefix=var cardurl=" "suffix=";" -->
+
+    document.location.href = cardurl;
+}
+
+// End hiding -->
+</SCRIPT>
+
+<LINK REL=stylesheet TYPE="text/css" HREF="/dsgwcmd/lang?<!-- GCONTEXT -->&amp;file=style.css">
+</HEAD>
+
+<!-- IF "!Displaying" -->
+<body bgcolor="#FFFFFF" style="marginheight:0; marginwidth:0; leftmargin:0; topmargin:0; rightmargin:0">
+<table width="100%" class="bgColor1" cellspacing="0" cellpadding="0" border="0">
+<tr style="width: 100%" class="bgColor1">
+<TD valign="top" class="bgColor1"><IMG src="/dsgwcmd/lang?<!-- GCONTEXT -->&amp;file=clear.gif" width="10" height="45" border="0"></TD>
+<TD valign="middle" align="left" class="text15" width="100%">MailRecipient Entry</td>
+</tr>
+</table>
+<table cellspacing="0" cellpadding="0">
+<tr>
+<td><IMG src="/dsgwcmd/lang?<!-- GCONTEXT -->&amp;file=clear.gif" width="1" height="10" border="0"></td>
+</tr>
+</table>
+<!-- ELSE -->
+<body bgcolor="#FFFFFF">
+<!-- ENDIF -->MailRecipient
+
+<div class="text22">
+<!-- DS_LAST_OP_INFO -->
+</div>
+<!-- DS_BEGIN_ENTRYFORM -->
+
+<TABLE><TR>
+<TD>
+<!-- DS_ATTRIBUTE "attr=jpegPhoto" "type=hidden" "options=typeonly" -->
+<!-- IF "AttributeHasValues" "jpegPhoto" -->
+<IMG SRC=
+<!-- DS_ATTRIBUTE "attr=jpegPhoto" "options=link" "mimetype=image/jpeg" -->
+BORDER=0></TD>
+<TD>
+<!-- ENDIF -->
+<A HREF="javascript:showVCard()">
+<IMG SRC="/dsgwcmd/lang?<!-- GCONTEXT -->&amp;file=person.gif" ALT="Person (click to show card)"
+    BORDER=0 HSPACE=5></A>
+</TD>
+<!-- IF "DisplayOrgChart" -->
+<TD>
+<A HREF=
+<!-- DS_ORGCHARTLINK -->
+ >
+<IMG SRC="/dsgwcmd/lang?<!-- GCONTEXT -->&amp;file=orgicon.gif" BORDER=0 ALT="Click to display organization chart" HSPACE=5></a>
+
+</TD>
+<!-- ENDIF -->
+<TD class="boldbig">
+<!-- IF "Adding" -->
+New MailRecipient -
+<!-- ENDIF // Adding -->
+<!-- DS_ATTRIBUTE "attr=dn" "syntax=dn" "dncomponents=2" "options=nolink" -->
+</TD></TR></TABLE>
+
+<!-- DS_ATTRIBUTE "attr=userCertificate;binary" "type=hidden" "options=typeonly" -->
+<!-- IF "AttributeHasValues" "userCertificate;binary" -->
+<A HREF=
+<!-- DS_ATTRIBUTE "attr=userCertificate;binary" "options=link" "mimetype=application/x-x509-email-cert" -->
+>Download Certificate</A>
+<!-- ENDIF -->
+
+<!-- DS_ATTRIBUTE "attr=userCertificate" "type=hidden" "options=typeonly" -->
+<!-- IF "AttributeHasValues" "userCertificate" -->
+<A HREF=
+<!-- DS_ATTRIBUTE "attr=userCertificate" "options=link" "mimetype=application/x-x509-email-cert" -->
+>Download Certificate</A>
+<!-- ENDIF -->
+
+<!-- DS_ATTRIBUTE "attr=audio" "type=hidden" "options=typeonly" -->
+<!-- IF "AttributeHasValues" "audio" -->
+&nbsp;&nbsp;
+<A HREF=
+<!-- DS_ATTRIBUTE "attr=audio" "options=link" "mimetype=audio/basic" -->
+>Play Audio Clip</A>
+<!-- ENDIF -->
+
+<TABLE><TR><TD>
+<!-- IF "Displaying" -->
+<INPUT TYPE="button" VALUE="Show Card" onClick="showVCard()">
+</TD><TD>&nbsp;&nbsp;</TD><TD>
+<!-- DS_EDITBUTTON "label=Edit MailRecipient" -->
+<!-- ELIF "Adding" -->
+<!-- DS_SAVEBUTTON "label=Save New MailRecipient" -->
+<!-- ELIF "Editing" -->
+<!-- DS_SAVEBUTTON -->
+<!-- ENDIF // Editing -->
+</TD><TD>&nbsp;&nbsp;</TD><TD>
+<!-- IF "!Displaying" -->
+<!-- DS_CLOSEBUTTON "label=Cancel" -->
+<!-- ENDIF // !Displaying -->
+</TD><TD>&nbsp;&nbsp;</TD><TD>
+<!-- IF "Editing" -->
+<!-- DS_HELPBUTTON "topic=EDIT_ORGPERSON" -->
+<!-- ELIF "Adding" -->
+<!-- DS_HELPBUTTON "topic=ADD_ORGPERSON" -->
+<!-- ENDIF // Adding -->
+</TD>
+
+<!-- IF "Editing" -->
+<TD>&nbsp;&nbsp;</TD><TD>
+<!-- DS_EDITASBUTTON "label=Change Password" "template=passwd" -->
+</TD><TD>
+<!-- DS_RENAMEBUTTON "label=Rename MailRecipient" "prompt=Enter a new name for this MailRecipient:" -->
+</TD><TD>
+<!-- DS_DELETEBUTTON "label=Delete MailRecipient" "prompt=Delete this MailRecipient?" -->
+</TD>
+<!-- ENDIF // Editing -->
+
+</TR></TABLE>
+
+<INPUT TYPE="hidden" NAME="desc_uid" VALUE="user id">
+<!-- PCONTEXT -->
+<!-- IF "Adding" -->
+<INPUT TYPE="hidden" NAME="add_objectClass" VALUE="top">
+<INPUT TYPE="hidden" NAME="add_objectClass" VALUE="mailRecipient">
+<!-- ENDIF // Adding -->
+
+<!-- PCONTEXT -->
+<INPUT TYPE="hidden" NAME="quiet" VALUE="true">
+<!-- DS_STD_COMPLETION_JS -->
+
+<!-- IF "!Displaying" -->
+<div class="text22"><B>&nbsp; * Indicates a required field<BR></B></div>
+<!-- ENDIF -->
+
+<TABLE CELLSPACING="2" BGCOLOR=#FFFFFF WIDTH=95%>
+<TR>
+<TH COLSPAN=4 align=left>
+  Contact Information
+  </TH>
+</TR>
+
+<TR>
+<TD NOWRAP
+<!-- IF "Displaying" -->
+    class="boldtop"
+<!-- ELSE -->
+    class="vertop"
+<!-- ENDIF -->
+>User ID:
+<!-- IF "!Displaying" -->
+<B>*</B>
+<!-- ENDIF -->
+</TD>
+<TD class="vertop" NOWRAP>
+<!-- DS_ATTRIBUTE "attr=uid" "cols=>16" "options=unique" -->
+</TD>
+<TD NOWRAP
+<!-- IF "Displaying" -->
+    class="boldtop"
+<!-- ELSE -->
+    class="vertop"
+<!-- ENDIF -->
+>E-Mail Address:
+<!-- IF "!Displaying" -->
+<B>*</B>
+<!-- ENDIF -->
+</TD>
+<TD class="vertop" NOWRAP>
+<!-- DS_ATTRIBUTE "attr=mail" "syntax=mail" "cols=>23" -->
+</TD>
+</TR>
+
+<!-- IF "Adding" -->
+<TR>
+<TD class="vertop">Password:<B>*</B></TD><TD>
+<!-- DS_NEWPASSWORD "cols=>16" -->
+</TD>
+<TD class="vertop"> Repeat password to confirm:<B>*</B></TD><TD>
+<!-- DS_CONFIRM_NEWPASSWORD "cols=>16" -->
+</TD></TR>
+<!-- ENDIF // Adding -->
+
+<TR>
+<TD NOWRAP
+<!-- IF "Displaying" -->
+    class="boldtop"
+<!-- ELSE -->
+    class="vertop"
+<!-- ENDIF -->
+>Message Store:
+<!-- IF "!Displaying" -->
+<B>*</B>
+<!-- ENDIF -->
+</TD>
+<TD class="vertop" NOWRAP>
+<!-- DS_ATTRIBUTE "attr=mailMessageStore" "syntax=ces" "cols=>23" -->
+</TD>
+<TD NOWRAP
+<!-- IF "Displaying" -->
+    class="boldtop"
+<!-- ELSE -->
+    class="vertop"
+<!-- ENDIF -->
+>Mail Quota:</TD>
+<TD class="vertop" NOWRAP>
+<!-- DS_ATTRIBUTE "attr=mailQuota" "syntax=cis" "cols=>16" -->
+</TD>
+</TR>
+
+<TR>
+<TD NOWRAP
+<!-- IF "Displaying" -->
+    class="boldtop"
+<!-- ELSE -->
+    class="vertop"
+<!-- ENDIF -->
+>Delivery Option:</TD>
+<TD class="vertop" NOWRAP>
+<!-- DS_ATTRIBUTE "attr=mailDeliveryOption"  "syntax=ces" "cols=>16" -->
+</TD>
+<TD NOWRAP
+<!-- IF "Displaying" -->
+    class="boldtop"
+<!-- ELSE -->
+    class="vertop"
+<!-- ENDIF -->
+>Forwarding Address:</TD>
+<TD class="vertop" NOWRAP>
+<!-- IF "Displaying" -->
+<!-- DS_ATTRIBUTE "attr=mailForwardingAddress" "syntax=mail" "cols=>23" -->
+<!-- ELIF "Adding" -->
+<!-- DS_ATTRIBUTE "attr=mailForwardingAddress" "syntax=mail" "numfields=+3" "cols=>23" -->
+<!-- ELIF "!AttributeHasValues" "mailForwardingAddress" -->
+<!-- DS_ATTRIBUTE "attr=mailForwardingAddress" "syntax=mail" "numfields=+3" "cols=>23" -->
+<!-- ELSE -->
+<!-- DS_ATTRIBUTE "attr=mailForwardingAddress" "syntax=mail" "numfields=+2" "cols=>23" -->
+<!-- ENDIF -->
+</TD>
+</TR>
+
+</TABLE>
+
+<TABLE CELLSPACING="2" BGCOLOR=#FFFFFF WIDTH=95%>
+<TR>
+<TH align=left COLSPAN=2>
+Location Information</TH>
+</TR>
+
+<TR>
+<TD NOWRAP
+<!-- IF "Displaying" -->
+    class="boldtop"
+<!-- ELSE -->
+    class="vertop"
+<!-- ENDIF -->
+>Organizational Unit:</TD>
+<TD class="vertop" NOWRAP>
+<!-- DS_ATTRIBUTE "attr=ou" "cols=>16" -->
+</TD></TR>
+
+</TABLE>
+
+<TABLE CELLSPACING="2" BGCOLOR=#FFFFFF WIDTH=95%>
+<TR>
+<TH align=left COLSPAN=2>
+Additional Information</TH>
+</TR>
+
+<TR>
+<TD NOWRAP
+<!-- IF "Displaying" -->
+    class="boldtop"
+<!-- ELSE -->
+    class="vertop"
+<!-- ENDIF -->
+>Description:</TD>
+<TD class="vertop" NOWRAP>
+<!-- DS_ATTRIBUTE "attr=description" "cols=>50" -->
+</TD></TR>
+
+<TR>
+<TD NOWRAP
+<!-- IF "Displaying" -->
+    class="boldtop"
+<!-- ELSE -->
+    class="vertop"
+<!-- ENDIF -->
+>See Also:<BR>
+<!-- IF "!Adding" -->
+<!-- DS_DNEDITBUTTON "label=Edit..." "template=dnedit" "attr=seeAlso" "desc=See Also" -->
+<!-- ENDIF // !Adding -->
+</TD>
+<TD class="vertop" NOWRAP>
+<!-- IF "Adding" -->
+<I>You must save this entry before you can edit this field.</I>
+<!-- ELSE // !Adding -->
+
+<!-- DS_ATTRIBUTE "attr=seeAlso" "syntax=dn" "options=readonly" -->
+
+<!-- ENDIF // !Adding -->
+</TD></TR>
+
+<TR>
+<TD NOWRAP
+<!-- IF "Displaying" -->
+    class="boldtop"
+<!-- ELSE -->
+    class="vertop"
+<!-- ENDIF -->
+>URL:</TD>
+<TD class="vertop" NOWRAP>
+<!-- DS_ATTRIBUTE "attr=labeledURI" "syntax=url" "cols=>50" "options=sort" -->
+</TD></TR>
+
+<!-- The following attribute should only be uncommented if you have
+     a need to allow editing of the x500UniqueIdentifier attribute.
+     Most installations will not need this functionality.
+<TR>
+<TD NOWRAP
+<!-- IF "Displaying" -->
+    class="boldtop"
+<!-- ELSE -->
+    class="vertop"
+<!-- ENDIF -->
+>Unique ID:</TD>
+<TD class="vertop" NOWRAP>
+<!-- DS_ATTRIBUTE "attr=x500uniqueidentifier" "cols=>50" -->
+</TR>
+-->
+<tr><td colspan="2" class="bgColor9">&nbsp;</td></tr>
+
+</TABLE>
+
+<!-- IF "!Adding" -->
+
+<div class="text22">
+&nbsp; This entry was last modified on <B>
+<!-- DS_ATTRIBUTE "attr=modifyTimestamp" "syntax=time" "defaultvalue=N/A" "options=readonly" -->
+</B> by <B>
+<!-- DS_ATTRIBUTE "attr=modifiersName" "syntax=dn" "defaultvalue=N/A" "options=readonly" -->
+</B>
+</div>
+
+<!-- ENDIF // !Adding -->
+
+<!-- DS_END_ENTRYFORM -->
+<!-- DS_ENTRYEND -->
+
+<!-- ENDHTML -->
diff -urN config.org/display-ntperson.html config/display-ntperson.html
--- config.org/display-ntperson.html	2009-08-14 01:25:09.000000000 +0900
+++ config/display-ntperson.html	2011-02-28 14:15:45.000000000 +0900
@@ -180,7 +180,6 @@
 <INPUT TYPE="hidden" NAME="add_objectClass" VALUE="organizationalPerson">
 <INPUT TYPE="hidden" NAME="add_objectClass" VALUE="inetOrgPerson">
 <INPUT TYPE="hidden" NAME="add_objectClass" VALUE="nTUser">
-<INPUT TYPE="hidden" NAME="add_objectClass" VALUE="nsaimpresence">
 <!-- ENDIF // Adding -->
 
 <INPUT TYPE="hidden" NAME="desc_uid" VALUE="user id">
diff -urN config.org/display-orgperson.html config/display-orgperson.html
--- config.org/display-orgperson.html	2011-03-01 14:16:46.000000000 +0900
+++ config/display-orgperson.html	2011-03-01 14:17:56.000000000 +0900
@@ -183,7 +183,6 @@
 <INPUT TYPE="hidden" NAME="add_objectClass" VALUE="person">
 <INPUT TYPE="hidden" NAME="add_objectClass" VALUE="organizationalPerson">
 <INPUT TYPE="hidden" NAME="add_objectClass" VALUE="inetOrgPerson">
-<INPUT TYPE="hidden" NAME="add_objectClass" VALUE="nsaimpresence">
 <!-- ENDIF // Adding -->
 
 <!-- PCONTEXT -->
diff -urN config.org/display-person.html config/display-person.html
--- config.org/display-person.html	2011-03-01 14:17:00.000000000 +0900
+++ config/display-person.html	2011-03-01 14:18:10.000000000 +0900
@@ -145,7 +145,6 @@
 <!-- IF "Adding" -->
 <INPUT TYPE="hidden" NAME="add_objectClass" VALUE="top">
 <INPUT TYPE="hidden" NAME="add_objectClass" VALUE="person">
-<INPUT TYPE="hidden" NAME="add_objectClass" VALUE="nsaimpresence">
 <!-- ENDIF // Adding -->
 
 <!-- PCONTEXT -->
diff -urN config.org/dsgwfilter.conf config/dsgwfilter.conf
--- config.org/dsgwfilter.conf	2009-08-14 01:25:09.000000000 +0900
+++ config/dsgwfilter.conf	2011-04-06 15:30:49.000000000 +0900
@@ -162,4 +162,29 @@
                         "(ntuserdomainid=%v))"	"NT username is"
 			"(|(cn=*%v1*)(sn=*%v1*)(cn~=%v1)(sn~=%v1)))"	"name sounds like or contains"
 
+"dsgw-mailrecipient"
+    "="			" "	"(%v))"			"LDAP filter is"
+
+    "^[0-9][0-9]*$"	" "	"(mailQuota=%v))"	"quota is"
+
+    "^(forward|bcc|autoreply|hold|mailbox|native)$"	" "	"(mailDeliveryOption=%v))"	"delivery option is"
+
+    "@"			" "	"(mail=%v))"		"email address is"
+				"(mail=%v*))"		"email address starts with"
+				"(mail=*%v))"		"email address end with"
+				"(mailForwardingAddress=%v))"	"forwarding address is"
+				"(mailForwardingAddress=%v*))"	"forwarding address starts with"
+				"(mailForwardingAddress=*%v))"	"forwarding address end with"
+
+    "^\*$"		" "	"(uid=*))"		"user id is"
+
+    ".*"		" "	"(uid=%v))"		"user id is"
+				"(uid=*%v*))"		"user id contains"
+				"(uid~=%v))"		"user id sounds like"
+				"(mailMessageStore=%v))"	"message store is"
+				"(mailMessageStore=*%v*))"	"message store contains"
+				"(mailMessageStore~=%v))"	"message store sounds like"
+				"(mailDeliveryOption=%v))"	"delivery option is"
+
+
 # Do not remove this line, or place any directives after it.
diff -urN config.org/dsgwsearchprefs.conf config/dsgwsearchprefs.conf
--- config.org/dsgwsearchprefs.conf	2009-08-14 01:25:09.000000000 +0900
+++ config/dsgwsearchprefs.conf	2011-04-06 15:30:48.000000000 +0900
@@ -66,6 +66,30 @@
 END
 
 
+"MailRecipient"
+""
+"Search For:"
+"(&(objectClass=mailRecipient)"
+"dsgw-mailrecipient"
+not-used-by-dsgw
+not-used-by-dsgw
+subtree
+"user id"                       "uid"                   111111  "" ""
+"e-mail address"                "mail"                  111111  "" ""
+"message store"                 "mailMessageStore"      111111  "" ""
+"delivery option"               "mailDeliveryOption"    000011  "" ""
+"forwarding address"            "mailForwardingAddress" 111111  "" ""
+"mail quota"                    "mailQuota"             000011  "" ""
+END
+"is"               		"(%a=%v))"
+"is not"               		"(!(%a=%v)))"
+"sounds like" 		        "(%a~=%v))"
+"starts with"                   "(%a=%v*))"
+"ends with"                     "(%a=*%v))"
+"contains"                      "(%a=*%v*))"
+END
+
+
 "NT-People"
 ""
 "Search For:"
diff -urN config.org/list-MailRecipient.html config/list-MailRecipient.html
--- config.org/list-MailRecipient.html	1970-01-01 09:00:00.000000000 +0900
+++ config/list-MailRecipient.html	2011-03-03 14:07:57.000000000 +0900
@@ -0,0 +1,152 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN"
+    "http://www.w3.org/TR/html4/strict.dtd">
+<html>
+<!-- BEGIN COPYRIGHT BLOCK
+ This Program is free software; you can redistribute it and/or modify it under
+ the terms of the GNU General Public License as published by the Free Software
+ Foundation; version 2 of the License.
+
+ This Program is distributed in the hope that it will be useful, but WITHOUT
+ ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+ FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
+
+ You should have received a copy of the GNU General Public License along with
+ this Program; if not, write to the Free Software Foundation, Inc., 59 Temple
+ Place, Suite 330, Boston, MA 02111-1307 USA.
+
+ 
+ Copyright (C) 2001 Sun Microsystems, Inc. Used by permission.
+ Copyright (C) 2005 Red Hat, Inc.
+ All rights reserved.
+  END COPYRIGHT BLOCK -->
+<!-- HEAD -->
+<LINK REL=stylesheet TYPE="text/css" HREF="/dsgwcmd/lang?<!-- GCONTEXT -->&amp;file=style.css">
+<TITLE>Search for MailRecipient</TITLE>
+
+</HEAD>
+<BODY BGCOLOR="white">
+
+<!-- IF "FoundEntries" -->
+
+<table width="85%" border="0" cellpadding="0" cellspacing="0" bgcolor="#CCCCCC" align="center">
+  <tr valign="top" bgcolor="#FFFFFF">
+    <td  bgcolor="white">
+      
+<!-- DS_SEARCHDESC -->
+      
+      <br>&nbsp;
+    </td>
+  </tr>
+  <tr>
+    <td>
+
+<table border="0" cellpadding="1" cellspacing="0" width="100%" bgcolor="#FFFFFF" align="center">
+  <tr align="left" bgcolor="#CCCCCC">
+    <td class="boldbig">
+        ID
+    </td>
+    <td class="boldbig">
+        E-mail
+    </td>
+    <td class="boldbig">
+        Message Store
+    </td>
+    <td class="boldbig">
+        Group
+     </td> 
+  </tr>
+<!-- DS_SORTENTRIES "attr=uid" -->
+
+<!-- DS_ENTRYBEGIN -->
+  <tr valign="top" bgcolor="#FFFFFF">
+    <td >
+      
+<!-- DS_ATTRIBUTE "attr=dn" "syntax=dn" "hrefextra=onMouseOver=%22%0Awindow.status='Click here to view this entry in detail'; return true%22" -->
+      
+    </td>
+    <td>
+      
+<!-- DS_ATTRIBUTE "attr=mail" "syntax=mail" -->
+      
+    </td>
+    <td>
+      
+<!-- DS_ATTRIBUTE "attr=mailMessageStore" "syntax=ces" -->
+      
+    </td>
+    <td>
+      
+<!-- DS_ATTRIBUTE "attr=ou" "syntax=cis"-->
+      
+    </td>
+  </tr>
+  <tr>
+    <td colspan="5"></td>
+  </tr>
+<!-- DS_ENTRYEND -->
+
+</table>
+
+    </td>
+  </tr>
+  <tr bgcolor="#FFFFFF">
+    <td>
+      &nbsp;<br>
+      
+        Click on an entry's ID to bring up more information about that entry.
+      
+    </td>
+  </tr>
+</table>
+
+<!-- ELSE -->
+<p>
+  <center>
+<TABLE width=360 height=216 border=1 bgcolor=#CCCCCC align=center>
+    <TR valign=top>
+    <TD>
+<TABLE width=356 border=0 cellpadding=18 cellspacing=0 bgcolor=#CCCCCC>
+    <TR valign=top>
+    <TD>
+      <CENTER>
+        <TABLE width=320 border=0 height=168 cellpadding=0 cellspacing=0 bgcolor=#CCCCCC>
+                    <TR valign=top>
+            <TD width=32>
+              <IMG src="/dsgwcmd/lang?<!-- GCONTEXT -->&amp;file=message.gif" height=32 width=32 border=0>
+            </TD>
+            <TD width=9>
+              &nbsp;
+            </TD>
+            <TD>
+              <P>
+                
+                No match found.
+                
+              </P>
+            </TD>
+          </TR>
+          <TR valign=top>
+            <TD colspan=2>
+            </TD>
+            <TD>
+              <P>
+                
+                No entries match the requested search term. Please try a different search.
+                
+              </P>
+            </TD>
+          </TR>
+        </TABLE>
+     </CENTER>
+    </TD>
+  </TR>
+</TABLE>
+    </TD>
+  </TR>
+</TABLE>
+  </center>
+</p>
+<!-- ENDIF -->
+
+<!-- ENDHTML -->
+